#ifndef AURODRIVE_NOP_RTK_MEASURE_H
#define AURODRIVE_NOP_RTK_MEASURE_H

//#ifndef EIGEN_DONT_ALIGN_STATICALLY
//#define EIGEN_DONT_ALIGN_STATICALLY
//#endif

#include "base_measure.h"
namespace Localization {
namespace Ego {
    
class RtkMeasure : public BaseMeasure {
public:
    RtkMeasure() = delete;
    RtkMeasure(const RtkMeasure &) = delete;
    RtkMeasure & operator=(const RtkMeasure &) = delete;
    RtkMeasure(const MeasurementType &mType, const InsInfo &insInfo);
    void CheckValid();
    // ****** function ****** //
    bool Update(const State &state, State &nextState) override;
    Eigen::VectorXd MeasurementEquation(const State &state) const;
    bool UpdateStateGnss(const State &state, State &nextState, const Eigen::VectorXd &innov,
         const Eigen::MatrixXd &mH);
    void ObserveRTK(const State &state, State &nextState, Eigen::VectorXd &innov,
                                    Eigen::MatrixXd &mH);

    unsigned int positionType_ = 0;
    unsigned int satUseNum_ = 0;
    unsigned int satInViewNum_ = 0;
    unsigned int solutionStatus = 0;
    unsigned int utmZoneNum = 0;
    double velocityVeh_{0.0};
    Eigen::Vector3d posUTM_{0,0,0};
    Eigen::Vector3d posLLA_{0,0,0};
    Eigen::Vector3d veloENU_{0,0,0};
    Eigen::Quaterniond quatUTM_{1,0,0,0};
    Eigen::Vector3d attitude_{0,0,0,};
    Eigen::Vector3d attitudeDual_{0,0,0};
    Eigen::Vector3d installGnss_;
    double heading_{0};
    double cog_{0};
    Eigen::Vector3d posLLAStd_{0,0,0};
    Eigen::Vector3d posUTMStd_{0,0,0};
    Eigen::Vector3d veloENUStd_{0,0,0};
    Eigen::Vector3d attStd_{0,0,0};
    const double gnssRVar_ = 0.1 * 0.1;
    const double gnssPVar_ = 0.1 * 0.1;

    double interval_;
    static double latestUpdateTime_;
}; // class RtkMeasure

} // namespace Ego
} // namespace Localization
#endif
